﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.OleDb;


namespace ContaBancaria_poo
{
    class Program
    {
        public static class AcessoaoBanco
        {
            public static OleDbConnection AbreConexao()
            { 
                return new OleDbConnection (@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source = d:\contapoo\banco.mdb");
            }
        }

        public class ContaBancaria
        {
            public string Nro_Conta { get; set; }
            public double Saldo { get; set; }

            public void Deposito()
            {
                string qualconta;
                double qualvalor;
                OleDbConnection conexao = AcessoaoBanco.AbreConexao();
                OleDbCommand comando = new OleDbCommand();
                comando.Connection = conexao;
                Console.Write("Qual é o número da conta para depósito? ");
                qualconta = Console.ReadLine();
                comando.CommandText = "Select * from conta where nro_conta =  \""+qualconta+"\"";
                try
                {
                    conexao.Open();
                    OleDbDataReader resultado = comando.ExecuteReader();
                    if (resultado.HasRows)
                    {
                        resultado.Read();
                        this.Nro_Conta = resultado["nro_conta"].ToString();
                        this.Saldo = resultado.GetDouble(1);
                        //this.saldo = Convert.ToDouble(resultado["saldo"]);
                        resultado.Close();
                        Console.Write("Qual é o valor do depósito? ");
                        qualvalor = Convert.ToDouble(Console.ReadLine());
                        comando.CommandText = "Insert into operacoes values (\""+qualconta + "\",\"D\",\""+qualvalor+"\")" ;
                        comando.ExecuteNonQuery();
                        this.Saldo += qualvalor;
                        comando.CommandText = "Update conta set saldo = \"" + this.Saldo + "\" where nro_conta = \"" + qualconta + "\"";
                        comando.ExecuteNonQuery();
                        Console.WriteLine("Depósito de {0} efetuado", qualvalor.ToString()); 
                        Console.WriteLine("O novo saldo é {0}",this.Saldo.ToString());
                        conexao.Close();
                    }
                    else
                    {
                        Console.WriteLine("A conta {0} não existe!", qualconta);
                    }
                }
                catch (OleDbException erro)
                {
                    Console.WriteLine("Erro: {0}", erro.Errors[0].Message);
                }
            }

            public void Saque()
            {
                string qualconta;
                double qualvalor;
                OleDbConnection conexao = AcessoaoBanco.AbreConexao();
                OleDbCommand comando = new OleDbCommand();
                comando.Connection = conexao;
                Console.Write("Qual é o número da conta para saque? ");
                qualconta = Console.ReadLine();
                comando.CommandText = "Select * from conta where nro_conta =  \"" + qualconta + "\"";
                try
                {
                    conexao.Open();
                    OleDbDataReader resultado = comando.ExecuteReader();
                    if (resultado.HasRows)
                    {
                        resultado.Read();
                        this.Nro_Conta = resultado["nro_conta"].ToString();
                        this.Saldo = resultado.GetDouble(1);
                        //this.saldo = Convert.ToDouble(resultado["saldo"]);
                        resultado.Close();
                        Console.Write("Qual é o valor do saque? ");
                        qualvalor = Convert.ToDouble(Console.ReadLine());
                        if (qualvalor <= this.Saldo)
                        {
                            comando.CommandText = "Insert into operacoes values (\"" + qualconta + "\",\"S\",\"" + qualvalor + "\")";
                            comando.ExecuteNonQuery();
                            this.Saldo -= qualvalor;
                            comando.CommandText = "Update conta set saldo = \"" + this.Saldo + "\" where nro_conta = \"" + qualconta + "\"";
                            comando.ExecuteNonQuery();
                            Console.WriteLine("Saque de {0} efetuado", qualvalor.ToString());
                            Console.WriteLine("O novo saldo é {0}", this.Saldo.ToString());
                        }
                        else
                        {
                            Console.WriteLine("Não existe saldo suficiente!");
                        }
                            conexao.Close();
                    }
                    else
                    {
                        Console.WriteLine("A conta {0} não existe!", qualconta);
                    }
                }
                catch (OleDbException erro)
                {
                    Console.WriteLine("Erro: {0}", erro.Errors[0].Message);
                }
            }
        }
        
        
        static void Main(string[] args)
        {
            ContaBancaria minhaconta = new ContaBancaria();
            minhaconta.Saque();
            Console.ReadKey();
        }
    }
}
